传送门
最大字符串配对数目:给你一个下标从0开始的数组 words ,数组中包含互不相同的字符串。
如果字符串words[i]与字符串words[j]满足以下条件,我们称它们可以匹配:
示例 1:
输入:words = [“cd”,“ac”,“dc”,“ca”,“zz”]
输出:2
解释:在此示例中,我们可以通过以下方式匹配 2 对字符串:
我们将第 0 个字符串与第 2 个字符串匹配,因为 word[0] 的反转字符串是 “dc” 并且等于 words[2]。
我们将第 1 个字符串与第 3 个字符串匹配,因为 word[1] 的反转字符串是 “ca” 并且等于 words[3]。
可以证明最多匹配数目是 2 。
示例 2:
输入:words = [“ab”,“ba”,“cc”]
输出:1
解释:在此示例中,我们可以通过以下方式匹配 1 对字符串:
我们将第 0 个字符串与第 1 个字符串匹配,因为 words[1] 的反转字符串 “ab” 与 words[0] 相等。
可以证明最多匹配数目是 1 。
示例 3:
输入:words = [“aa”,“ab”]
输出:0
解释:这个例子中,无法匹配任何字符串。
class Solution {
public:
int maximumNumberOfStringPairs(vector<string>& words) {
int count = 0;
for(int i = 0; i < words.size(); ++i){
for(int j = i + 1; j < words.size(); ++j){
string s = words[j];
reverse(s.begin(),s.end());
if(words[i] == s) count++;
}
}
return count;
}
};
暴力求解,通过两次循环进行结果的求解。
时间复杂度:
O(n2)
空间复杂度:
O(1)
class Solution {
public:
int maximumNumberOfStringPairs(vector<string>& words) {
int n = words.size();
int ans = 0;
unordered_set<int> seen;
for (int i = 0; i < n; ++i) {
if (seen.count(words[i][1] * 100 + words[i][0])) {
++ans;
}
seen.insert(words[i][0] * 100 + words[i][1]);
}
return ans;
}
};
作者:力扣官方题解
链接:https://leetcode.cn/problems/find-maximum-number-of-string-pairs/solutions/2604698/zui-da-zi-fu-chuan-pei-dui-shu-mu-by-lee-0x0e/
来源:力扣(LeetCode)
著作权归作者所有。商业转载请联系作者获得授权,非商业转载请注明出处。
我们也可以借助哈希集合,只进行一次遍历。
当我们枚举到words[i]时,我们将之前的所有字符串words[0…i?1]放入哈希集合中。如果words[i]的反转字符串在哈希集合中存在,那么匹配的数量增加1。
对于比较方便得到反转字符串的语言,我们可以在哈希集合中存储字符串本身;对于其它语言,我们可以存储字符串的哈希值,改为判断words[i]的反转字符串的哈希值是否存在。哈希值需要保证不会冲突,本题中字符串的长度为2并且只包含小写字母,因此可以使用100a+b作为哈希值,其中a和b分别是两个字符的ASCII值。
时间复杂度:
O(n)
空间复杂度:
哈希表,O(n)
以空间换取时间,可以考虑使用哈希表。
2024.1.17